
import DDC

import System.Random

main = runDDC anim

anim = do
  blankEverything
  mapM_ move positions

beadColor = Color 100 255 140 

move ((x,y),state) = do
  colorLamp (idFromPosition (x,y)) beadColor
  wait 80
  colorLamp (idFromPosition (x,y)) black

idFromPosition :: (Int,Int) -> LampID
idFromPosition (x,y) = SpecificLamp $ letterXYtoBulb $ letterXYfromPosition (x,y)

letterXYfromPosition :: (Int,Int) -> (Letter,Int,Int)
letterXYfromPosition (x,y) = let
   (nl,nx) = columnToLetterColumnPair x
 in (nl,nx,y)

letterXYtoBulb :: (Letter, Int, Int) -> BulbID
letterXYtoBulb (l,x,y) = let
     (bulb,_,_,_) = head $ filter (\(_,lM, xM, yM) -> l == lM && x == xM && y == yM) allLamps
   in bulb

-- for 100 seconds, at 5 moves per second, is 500 moves

positions = take 500 $ runMoves startState

runMoves s = [s] ++ (runMoves (nextState s))

seed = 0

startRnd = mkStdGen seed

-- we're going to have a co-ordinate space of 6 across and 3 deep, but with
-- three holes (the holes in the Cs), which means that the middle deep pixel
-- does not exist if the x co-ordinate is odd

startPos = (0,0)

startState = (startPos, startRnd)

nextState (oldPos, oldRnd) = let
      possibleNextPos = possibleMoves oldPos
      (chosenMove, nextRnd) = randomR (0, (length possibleNextPos) -1) oldRnd
      nextPos = possibleNextPos !! chosenMove
    in (nextPos, nextRnd)

possibleMoves (x,y) =  -- there are 8 possible moves
  (if y == 0 || y == 2 then horizontalMoves (x,y) else [] ) ++
  (if (x `rem` 2 == 0) then verticalMoves (x,y) else [])

horizontalMoves (x,y) = (if x>0 then [(x-1,y)] else []) ++ 
                         (if x<5 then [(x+1,y)] else [])

verticalMoves (x,y) = (if y>0 then [(x,y-1)] else []) ++
                       (if y<2 then [(x,y+1)] else [])

